package main

import (
	"testing"
)

func TestFoodToAnt(t *testing.T) {
	m := NewMap(4, 3)
	m.AddFood(m.FromRowCol(1, 1))
	m.AddAnt(m.FromRowCol(2, 1), MY_ANT)
	if m.String() != `. . . 
. * . 
. a . 
. . . 
` {
		t.Fatalf("unexpected map, got: `%s`", m)
	}
	ants := FindAntsCloseToFood(m)
	if ants == nil || len(ants) != 1 {
		t.Fatalf("didn't find the nearby ant: %v", ants)
	}
}

func TestFoodToAntBorders(t *testing.T) {
	m := NewMap(5, 8)
	m.AddFood(m.FromRowCol(2, 2))
	m.AddAnt(m.FromRowCol(0, 2), MY_ANT)
	m.AddWater(m.FromRowCol(1, 1))
	m.AddWater(m.FromRowCol(1, 2))
	m.AddWater(m.FromRowCol(1, 3))
	m.AddWater(m.FromRowCol(1, 4))
	m.AddWater(m.FromRowCol(2, 1))
	m.AddWater(m.FromRowCol(3, 1))
	m.AddWater(m.FromRowCol(3, 2))
	m.AddWater(m.FromRowCol(3, 3))
	m.AddWater(m.FromRowCol(3, 4))
	m.AddAnt(m.FromRowCol(2, 7), MY_ANT)
	exp := `. . a . . . . . 
. % % % % . . . 
. % * . . . . a 
. % % % % . . . 
. . . . . . . . 
`
	if m.String() != exp {
		t.Fatalf("unexpected map, got:\n%s  not\n%s", m.String(), exp)
	}
	ants := FindAntsCloseToFood(m)
	if ants == nil || len(ants) != 1 ||
		ants[0].ant != m.FromRowCol(2, 7) ||
		ants[0].food != m.FromRowCol(2, 2) {
		t.Fatalf("didn't find the nearby ant: %v", ants)
	}
}
